__package__    = "twgrowler.py"
__version__    = "1.0"
__author__     = "Aaron Straup Cope"
__url__        = "http://www.aaronland.info/python/twgrowler/"
__cvsversion__ = "$Revision: 1.1 $"
__date__       = "$Date: 2007/12/28 08:43:39 $"
__copyright__  = "Copyright (c) 2007 Aaron Straup Cope. Perl Artistic License."

import elementtree.ElementTree as ET
import growler
import httplib
import base64

class twgrowler (growler.growler) :

    def __init__ (self, cfg) :

        growler.growler.__init__(self, cfg)
        self.api_endpoint = "twitter.com"

    #

    def get_feed (self, uri, params=None) :

        headers =  self.get_twitter_auth()
        conn    = httplib.HTTPConnection(self.api_endpoint)

        try :
            conn.request('GET', uri, params, headers)
        except Exception, e:
            return None

        try :
            res = conn.getresponse()
            xml = res.read()
        except Exception, e:
            return None
        
        try :
            tree = ET.fromstring(xml)
            return tree
        except Exception, e :
            return None
        
    #
    
    def get_twitter_auth (self) :

        user = self.cfg.get(self.name, 'username')
        pswd = self.cfg.get(self.name, 'password')
        auth = base64.encodestring(user + ":" + pswd)
        
        self.__auth__ = {"Authorization":"Basic %s" % auth} 
        return self.__auth__

    #

    def notify (self, event) :

        title  = "%s (%s)" % (event['who'], event['where'])
        desc   = event['what']

        try :
            icon = self.fetch_thumb(event['icon'])
            self.growl.notify(self.name, title, desc, icon, True)
        except Exception, e :
            self.log("Failed to notify, %s" % e)
            return False

        return True
